#include "StdAfx.h"
#include "SendNoteMananger.h"
#include "MemoSendDlg.h"
#include "MemoAuthorize.h"

SendNoteMananger::SendNoteMananger(unsigned int nCapaOfSendDlgPool)
: m_nReceiverMaxCount(50)
, m_pMemoAuthorize(new CMemoAuthorize())
, m_nCapaOfSendDlgPool(nCapaOfSendDlgPool)
, m_pSendNoteMemberInfoActorEvent(new CNoteMemberInfoActorEvent(this))
{
}

SendNoteMananger::~SendNoteMananger(void)
{
	if (NULL != g_pMessengerActor)
		g_pMessengerActor->GetWASActor()->UnRegisterObserver(this);	

	if (NULL != m_pMemoAuthorize)
	{
		delete m_pMemoAuthorize;
		m_pMemoAuthorize = NULL;
	}

	if (NULL != m_pSendNoteMemberInfoActorEvent)
	{
		delete m_pSendNoteMemberInfoActorEvent;
		m_pSendNoteMemberInfoActorEvent =NULL;
	}
}

void SendNoteMananger::InitSendNoteDialogPool()
{
	/*int nCount = m_nCapaOfSendDlgPool - m_listSendDialogPool.size();
	for (int i = 0; i < nCount ; i++)
	{
		StuffSendNoteDialogPool();
	}*/
}

void SendNoteMananger::ClearSendNoteDialogPool()
{
	/*CSingleLock lock(&m_csCreateMemoSendDlgThread);
	lock.Lock();
	if( lock.IsLocked() )
	{
		for(size_t i = 0; i < m_listSendDialogPool.size(); i++)
		{
			CMemoSendDlg *pDlg = m_listSendDialogPool[i];
			if( pDlg->GetSafeHwnd() != NULL )
			{
				pDlg->DestroyWindow();
				delete pDlg;
			}
		}

		m_listSendDialogPool.clear();

		lock.Unlock();
	}*/
}

void SendNoteMananger::CreateSendNoteDlg(CCreateSendNoteDlgThread *pCreateSendDlgThread)
{
	CSingleLock lock(&m_csCreateMemoSendDlgThread);
	lock.Lock();
	if( lock.IsLocked() )
	{
		CMemoSendDlg* pDialog = new CMemoSendDlg();
		if (NULL != pDialog)
		{
			pDialog->Create(CMemoSendDlg::IDD, CWnd::GetDesktopWindow());
			pDialog->ShowWindow(SW_HIDE);

			// dummy initialize
			pDialog->SetNoteNo(0);
			pDialog->SetSendType(_T("new"));
			pDialog->SetPreCreationDialog(NULL);
			pDialog->InitializeSmartEditor();
		
			// bind thread and dialog
			//m_listSendDialogPool.push_back(pDialog);

			pDialog->InitializeAll();
		}

		lock.Unlock();
	}
}

void SendNoteMananger::StuffSendNoteDialogPool()
{
	CCreateSendNoteDlgThread *pCreateSendDlgThread = (CCreateSendNoteDlgThread*)AfxBeginThread(RUNTIME_CLASS(CCreateSendNoteDlgThread), THREAD_PRIORITY_NORMAL, 0, CREATE_SUSPENDED);
	if( pCreateSendDlgThread != NULL )
	{
		pCreateSendDlgThread->SetDlgManager(this);
		pCreateSendDlgThread->ResumeThread();
	}
}

CMemoSendDlg* SendNoteMananger::GetMemoSendDlgFromPool()
{
	CMemoSendDlg* pDialog = new CMemoSendDlg();
	if (NULL == pDialog)
		return NULL;

	pDialog->Create(CMemoSendDlg::IDD, CWnd::GetDesktopWindow());

	/*CSingleLock lock(&m_csCreateMemoSendDlgThread);
	lock.Lock();
	if( lock.IsLocked() )
	{
		if( m_listSendDialogPool.empty() != true )
		{
			vector<CMemoSendDlg*>::iterator itr = m_listSendDialogPool.begin();
			pDialog = (*itr);
			m_listSendDialogPool.erase(itr);
		}

		lock.Unlock();
	}

	StuffSendNoteDialogPool();*/

	return pDialog;
}

void SendNoteMananger::MakeMemoSendDlg( std::vector<ReceiverInfo> &receiverVector )
{
	Create(receiverVector);
}

void SendNoteMananger::MakeMemoSendDlg( CString strWriteModeParam, ULONGLONG lNoteNum, CWnd* pCreationDlg)
{
	CMemoSendDlg* pDialog = GetMemoSendDlgFromPool();
	if( pDialog == NULL )
		return;

	pDialog->SetNoteNo(lNoteNum);
	pDialog->SetSendType(strWriteModeParam);
	pDialog->SetPreCreationDialog(pCreationDlg);
	pDialog->InitializeAll();

	if (pDialog->IsInitializeSuccess())
	{
		if( strWriteModeParam.Compare(_T("new")) == 0)
		{
			pDialog->ShowWindow(SW_SHOW);
		}

		m_listDialog.AddTail((CObject*)pDialog);
	}
	else
	{
		delete pDialog;
		pDialog = NULL;
	}

}

void SendNoteMananger::MakeMemoSendDlg( const std::vector<ReceiverInfo> receiverVector, CString strTitle, CString strContent )
{
	if (receiverVector.size() > m_nReceiverMaxCount)
	{
		CString strMsg;
		if(m_nReceiverMaxCount < 1000)
			strMsg.LoadString(IDS_STRING296);
		else
			strMsg.LoadString(IDS_STRING300);

		NMessageBox(NULL, strMsg);
	}
	else
	{
		CMemoSendDlg* pDialog = GetMemoSendDlgFromPool();
		if (NULL == pDialog)
			return;
		pDialog->SetNoteInfo(strTitle,strContent);

		pDialog->SetAddresseeVector(receiverVector);
		pDialog->InitializeAll();
		pDialog->InitializeSmartEditor();

		if (pDialog->IsInitializeSuccess())
		{
			pDialog->ShowWindow(SW_SHOW);
			m_listDialog.AddTail((CObject*)pDialog);
		}
		else
		{
			pDialog->DestroyWindow();
			delete pDialog;
			pDialog = NULL;
		}
	}
}

// UserID  UserName   Ѵ.
void SendNoteMananger::PreMakeMemoSendDlg( const std::vector<ReceiverInfo> receiverVector, CString strTitle, CString strContent )
{
	m_pSendNoteMemberInfoActorEvent->RequestSendNote(receiverVector,strTitle,strContent);
}

void SendNoteMananger::Remove( CDialog* pDialog )
{

	DialogManager::Remove(pDialog);
}

int SendNoteMananger::RemoveAll()
{
	for (POSITION pos = m_listDialog.GetHeadPosition(); pos != NULL;)
	{
		CMemoSendDlg *pDlg = (CMemoSendDlg*)m_listDialog.GetNext(pos);
		if( pDlg != NULL && pDlg->GetSafeHwnd() )
		{
			pDlg->CloseDialog();
		}
	}
	return 0;
}

void SendNoteMananger::RecvMemoDlgIsClosed(CDialog* pDialog)
{
	for (POSITION pos = m_listDialog.GetHeadPosition(); pos != NULL;)
	{
		CMemoSendDlg *pDlg = (CMemoSendDlg*)m_listDialog.GetNext(pos);
		if( pDlg != NULL && pDlg->GetSafeHwnd() )
		{
			pDlg->RecvMemoDlgIsClosed(pDialog);
		}
	}
}

void SendNoteMananger::SetReceiverMaxCount(int nCount)
{
	m_nReceiverMaxCount = nCount;
}

void SendNoteMananger::SetAuthorize(DWORD dwAuth)
{
	m_pMemoAuthorize->SetAuth(dwAuth);

	if( (dwAuth & AUTH_MEMO_NT02) == AUTH_MEMO_NT02 )
		SetReceiverMaxCount(1000);
}

DWORD SendNoteMananger::GetAuthorize()
{
	return m_pMemoAuthorize->GetAuth();
}

void SendNoteMananger::SetCurrentFileSize(ULONGLONG ullSize)
{
	m_pMemoAuthorize->SetCurrentFileSize(ullSize);
}

ULONGLONG SendNoteMananger::GetCurrentFileSize()
{
	return m_pMemoAuthorize->GetCurrentFileSize();
}


void SendNoteMananger::SetReadOnly( BOOL bStatus, CObject* pObject )
{
	CMemoSendDlg* pDialog = (CMemoSendDlg*) pObject;

	pDialog->SetReadOnly(bStatus);
}

void SendNoteMananger::CreateSingleBuddyNote( const IGTBuddyUser* pUser )
{
	ReceiverInfo receiverInfo;
	receiverInfo.strID = pUser->GetUserID();
	receiverInfo.strName = pUser->GetName();

	std::vector<ReceiverInfo> receiverVector;
	receiverVector.push_back(receiverInfo);

	
	Create(receiverVector);
}

void SendNoteMananger::CreateMemberListNote( const NE_MEMBER_DATA_LIST& list )
{
	std::vector<ReceiverInfo> receiverVector;
	ReceiverInfo receiverInfo;

	for(size_t i = 0; i < list.nSize; i++)
	{
		const NE_MEMBER_DATA &sMemberInfo = list.pList[i];
		receiverInfo.strID = sMemberInfo.strUserId.c_str();
		receiverInfo.strName = sMemberInfo.strName.c_str();
		receiverVector.push_back(receiverInfo);
	}

	Create(receiverVector);
}

void SendNoteMananger::Create( const std::vector<ReceiverInfo>& receiverVector )
{	
	if (receiverVector.size() > m_nReceiverMaxCount)
	{
		CString strMsg;
		if(m_nReceiverMaxCount < 1000)
			strMsg.LoadString(IDS_STRING296);
		else
			strMsg.LoadString(IDS_STRING300);

		NMessageBox(NULL, strMsg);
	}
	else
	{
		CMemoSendDlg* pDialog = NULL;
		pDialog = GetMemoSendDlgFromPool();
		if (NULL == pDialog)
			return;

		pDialog->SetAddresseeVector(receiverVector);
		pDialog->InitializeAll();
		pDialog->InitializeSmartEditor();

		if (pDialog->IsInitializeSuccess())
		{
			pDialog->ShowWindow(SW_SHOW);
			m_listDialog.AddTail((CObject*)pDialog);
			pDialog->SetSmartEditorFocus();
		}
		else
		{
			delete pDialog;
			pDialog = NULL;
		}
	}
}

void SendNoteMananger::Create( const std::vector<AttachFileInfo>& fileInfoVector, const std::vector<ReceiverInfo>& receiverVector )
{
	ULONGLONG dwTotalSize = 0;

	// File Size
	std::vector<AttachFileInfo>::const_iterator fileIterator = fileInfoVector.begin();
	for (; fileIterator != fileInfoVector.end(); ++fileIterator)
	{
		AttachFileInfo fileInfo = *fileIterator;

		CString strFilePath = fileInfo.flepath.c_str();
		int iFind = strFilePath.ReverseFind(_T('\\'));
		if (iFind == -1) 
			return;

		CString strName = strFilePath.Mid(iFind + 1);

		CFile file(strFilePath, CFile::modeRead | CFile::shareDenyNone);
		dwTotalSize += file.GetLength();
	}

	CString strMsg;

	//   -  
	CNoteModel noteModel;
	LRESULT res = noteModel.IsEnableReceiverUserCount( receiverVector.size() );
	if (res != 0L)
	{
		if(res == 1L)
			strMsg.LoadString(IDS_STRING296);
		else if(res == 2L)	
			strMsg.LoadString(IDS_STRING300);
		else if(res == 3L)	
			strMsg.LoadString(IDS_STRING298);

		NMessageBox(AfxGetMainWnd(), strMsg);
		return;
	}

	//    - ÷ 뷮
	res = noteModel.IsEnableSendFileInfo(dwTotalSize);
	if(res != 0L)
	{
		if(res == 1L)	
			strMsg.LoadString(IDS_STRING295);
		else if(res == 2L)	
			strMsg.LoadString(IDS_STRING299);
		else if(res == 3L)	
			strMsg.LoadString(IDS_STRING301);

		NMessageBox(AfxGetMainWnd(), strMsg);
		return;
	}

	//  ̾α
	CMemoSendDlg* pDialog = GetMemoSendDlgFromPool();
	if (NULL == pDialog)
		return;

	pDialog->ShowWindow(SW_SHOW);
	m_listDialog.AddTail((CObject*)pDialog);

	pDialog->SetAddresseeVector(receiverVector);
	pDialog->SetAttachFileListVector(fileInfoVector);

	//pDialog->InitializeAll();
	pDialog->InitializeBySendType();
	pDialog->InitializeAddressee();

	pDialog->InitializeSmartEditor();
}

void SendNoteMananger::CreateReceiverInfoListNote( const std::vector<ReceiverInfo>& receiverVector )
{
	Create(receiverVector);	
}

void SendNoteMananger::CreateBuddyListNote( const std::vector<const IGTBuddyUser*>& buddyVector )
{
	std::vector<ReceiverInfo> receiverVector;
	ReceiverInfo receiverInfo;

	std::vector<const IGTBuddyUser* >::const_iterator buddyIterator = buddyVector.begin();
	for (; buddyIterator != buddyVector.end(); ++buddyIterator)
	{
		const IGTBuddyUser* pUser = *buddyIterator;
		receiverInfo.strID = pUser->GetUserID();
		receiverInfo.strName = pUser->GetName();
		receiverVector.push_back(receiverInfo);
	}

	Create(receiverVector);
}

void SendNoteMananger::CreateListNote( const std::vector<ReceiverInfo>& vecReceiver )
{
	Create(vecReceiver);
}

void SendNoteMananger::CreateFileSendNote( const std::vector<AttachFileInfo>& fileInfoVector, const std::vector<ReceiverInfo>& receiverVector )
{
	Create(fileInfoVector, receiverVector);
}



void SendNoteMananger::SetViewLanguagePack()
{
	for(POSITION pos = m_listDialog.GetHeadPosition(); pos != NULL;)
	{
		CMemoSendDlg* pDialog =  (CMemoSendDlg*)m_listDialog.GetNext(pos);
		if(pDialog->GetSafeHwnd())
		{
			pDialog->__ResourceLoad();
		}
	}
}

bool SendNoteMananger::OnGTWASActor_ResponseGetAttachID(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, LPCSTR szAttachID)
{
	if (!pActor)
		return false;

	for(POSITION pos = m_listDialog.GetHeadPosition(); pos != NULL;)
	{
		CMemoSendDlg* pDialog =  (CMemoSendDlg*)m_listDialog.GetNext(pos);
		if (pDialog == NULL)
			break;
		if(pDialog->OnResponseGetAttachID(pActor, trid, eErrorCode, szAttachID) == false)
			break;
	}

	return false;
}

bool SendNoteMananger::OnGTWASActor_ResponseGetReplyBody(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, NoteReplyBody &replyBodyInfo)
{
	if (!pActor)
		return false;

	for(POSITION pos = m_listDialog.GetHeadPosition(); pos != NULL;)
	{
		CMemoSendDlg* pDialog =  (CMemoSendDlg*)m_listDialog.GetNext(pos);
		if(pDialog->OnResponseGetReplyBody(pActor, trid, eErrorCode, replyBodyInfo) == false)
			break;
	}

	return false;
}

bool SendNoteMananger::OnGTWASActor_ResponseSendNote(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode nWasErrorCode, int nJsonErrorCode, LPCWSTR strResponseMsg)
{
	if (!pActor)
		return false;

	for(POSITION pos = m_listDialog.GetHeadPosition(); pos != NULL;)
	{
		CMemoSendDlg* pDialog =  (CMemoSendDlg*)m_listDialog.GetNext(pos);
		if(pDialog->OnResponseSendNote(pActor, trid, nWasErrorCode, nJsonErrorCode, strResponseMsg) == false)
			break;
	}

	return false;
}

///////////////////////////////////////////////////////////////////////////////
// CCreateSendNotDlgThread
///////////////////////////////////////////////////////////////////////////////

IMPLEMENT_DYNCREATE(CCreateSendNoteDlgThread, CWinThread)

CCreateSendNoteDlgThread::CCreateSendNoteDlgThread()
: m_pDlgManager(NULL)
{
}

CCreateSendNoteDlgThread::~CCreateSendNoteDlgThread()
{
}

BOOL CCreateSendNoteDlgThread::InitInstance()
{
	return TRUE;
}

BEGIN_MESSAGE_MAP(CCreateSendNoteDlgThread, CWinThread)
END_MESSAGE_MAP()


int CCreateSendNoteDlgThread::Run()
{
	if( m_pDlgManager != NULL )
	{
		m_pDlgManager->CreateSendNoteDlg(this);
	}

	return CWinThread::Run();
}

void CCreateSendNoteDlgThread::SetDlgManager(SendNoteMananger *pDlgManager)
{
	m_pDlgManager = pDlgManager;
}
